<?php

/* SOFTWARE LOADER
   DO NOT change this file
----------------------------------*/

// Start session..
$ini_get = ini_get_all();
if (isset($ini_get['session.cookie_httponly'])) {
  ini_set('session.cookie_httponly', 1);
}
session_start();

date_default_timezone_set((function_exists('date_default_timezone_get') ? date_default_timezone_get() : 'Europe/London'));

// Set paths..
define('PATH', __dir__ . '/');
define('IPATH', __dir__ . '/../');
define('INC_FILES', 1);
define('PARENT', 1);

if (version_compare(phpversion(), '7.0', '<')) {
  die('PHP version too old, PHPv7.0 or higher required');
}

// Config..
if(file_exists(IPATH . 'control/_cfg.php')){include(IPATH . 'control/_cfg.php');}else{die('File "control/_cfg.php" is missing, please see installation instructions.');}

// Debugger
if (version_compare(PHP_VERSION, '8.0.0') >= 0) {
  include(IPATH . 'control/lib/tracy/vendor/tracy/tracy/src/tracy.php');
}
use Tracy\Debugger;
if (version_compare(PHP_VERSION, '8.0.0') >= 0) {
  // For development, report everything and enable tracy bar
  Debugger::$showBar = (defined('DEVELOPMENT_ENV') ? true : false);
  Debugger::$strictMode = (defined('DEVELOPMENT_ENV') ? true : false);
  Debugger::enable(Debugger::DEVELOPMENT, IPATH . 'logs');
}

// Load settings..
$SETTINGS = mysqli_fetch_object(mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM " . DB_PREFIX . "settings LIMIT 1 ")) or die(mysqli_error($GLOBALS["___mysqli_ston"]));

// Load paypal data..
$PP = mysqli_fetch_object(mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM " . DB_PREFIX . "paypal LIMIT 1")) or die(mysqli_error($GLOBALS["___mysqli_ston"]));

// Load include files..
if (!isset($SETTINGS->language)) {
  header("Location: ../install/index.php");
  exit;
}
include(IPATH . 'control/defined.php');
include(IPATH . 'content/lang/' . $SETTINGS->language);
include(IPATH . 'control/functions.php');
include(PATH . 'control/functions.php');
define('ADM_KEY', encrypt(SECRET_KEY));
include(PATH . 'control/defined.php');
include(IPATH . 'control/classes/class.ops.php');
include(PATH . 'control/classes/class.paginate.php');
include(IPATH . 'control/classes/class.watermarker.php');
include(IPATH . 'control/classes/mailer/class.mail.php');
include(PATH . 'control/classes/class.cats.php');
include(PATH . 'control/classes/class.sales.php');
include(IPATH . 'control/classes/class.cart.php');
include(PATH . 'control/classes/class.images.php');
include(PATH . 'control/classes/class.emails.php');
include(PATH . 'control/classes/class.ban.php');

// Default vars..
$cmd          = (isset($_GET['cmd']) ? $_GET['cmd'] : 'home');
$page         = (isset($_GET['page']) ? (int) $_GET['page'] : '1');
$count        = 0;
$limit        = DATA_PAGES;
$limitvalue   = $page * $limit - ($limit);
$error_string = [];
$pageTitle    = '';

// Create objects of class files..
$MGA_WMARK           = new waterMarker();
$MGA_CART            = new mga_Cart();
$MGA_MAIL            = new mailClass();
$MGA_IMAGES          = new images();
$MGA_CATS            = new cats();
$MGA_EMAILS          = new emailAddress();
$MGA_BAN             = new banOption();
$MGA_SALES           = new sales();
$MGA_MAIL->smtp_en   = $SETTINGS->smtp;
$MGA_MAIL->smtp_host = $SETTINGS->smtp_host;
$MGA_MAIL->smtp_user = $SETTINGS->smtp_user;
$MGA_MAIL->smtp_pass = $SETTINGS->smtp_pass;
$MGA_MAIL->smtp_port = $SETTINGS->smtp_port;
$MGA_MAIL->addTag('{WEBSITE_NAME}', $SETTINGS->website);
$MGA_MAIL->addTag('{WEBSITE_URL}', $SETTINGS->folder);
$MGA_MAIL->addTag('{WEBSITE_EMAIL}', $SETTINGS->email);

//----------------------------
//Load data file template
//----------------------------

switch ($cmd) {
  // Home..
  case 'home':

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu2;

    include(PATH . 'content/header.php');
    include(PATH . 'content/home.php');
    include(PATH . 'content/footer.php');
    break;

  // Settings..
  case "settings":

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu3;

    // Switch tabs..
    if (isset($_GET['tab'])) {
      $_SESSION['settings_tab' . ADM_KEY] = $_GET['tab'];
      header("Location: index.php?cmd=settings");
      exit;
    }

    // View Sample Watermark
    if (isset($_GET['watermark'])) {
      include(PATH . 'content/watermark.php');
      exit;
    }

    // Update settings..
    if (isset($_POST['process'])) {
      include(PATH . 'control/classes/class.settings.php');

      $MGA_SETTINGS = new settings();

      if (isset($_POST['generalbutton'])) {
        $MGA_SETTINGS->update_general($_POST);

        if (isset($_POST['reset'])) {
          $MGA_SETTINGS->clear();
        }
      }
      if (isset($_POST['imagesbutton'])) {
        $MGA_SETTINGS->update_images($_POST);
      }
      if (isset($_POST['waterbutton'])) {
        $MGA_SETTINGS->update_watermarks($_POST);
      }
      if (isset($_POST['cartbutton'])) {
        $MGA_SETTINGS->update_cart($_POST);
      }
      if (isset($_POST['smtpbutton'])) {
        $MGA_SETTINGS->update_smtp($_POST);
      }

      header("Location: index.php?cmd=settings");
      exit;
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/settings.php');
    include(PATH . 'content/footer.php');
    break;

  case 'comments':

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu14;

    // View/update pre-approved comments or current comments..
    if (isset($_GET['ccid']) || isset($_POST['edit_comment'])) {
      if (isset($_POST['edit_comment'])) {
        $MGA_IMAGES->update_comment($_POST);
        if (isset($_POST['imgid'])) {
          header("Location: index.php?cmd=cat_images&comments=" . $_POST['imgid']);
          exit;
        }
      }
      include(PATH . 'content/header.php');
      include(PATH . 'content/view_comments.php');
      include(PATH . 'content/footer.php');
      exit;
    }

    // Delete comment..
    if (isset($_GET['del'])) {
      $MGA_IMAGES->delete_comment((int) $_GET['del']);
      header("Location: index.php?cmd=" . $_GET['return'] . "&comments=" . $_GET['comments'] . "&cat=" . (int) $_GET['cat']);
      exit;
    }

    // Process comments..
    if (isset($_POST['process'])) {
      if (!empty($_POST['comment'])) {
        for ($i = 0; $i < count($_POST['comment']); $i++) {
          $split = explode("##", $_POST['comment'][$i]);
          $IMG   = getImageData($split[1]);
          $COM   = get_comment_data($split[0]);
          $CAT   = getCategoryData($IMG->cat);

          // Process..approve/reject..
          if (isset($_POST['approve'])) {
            $MGA_IMAGES->process_comment($split[0]);
          }
          if (isset($_POST['reject'])) {
            $MGA_IMAGES->process_comment($split[0], true);
          }

          // Send mail..
          if (isset($_POST['mail'])) {
            $MGA_MAIL->addTag('{NAME}', $COM->name);
            $MGA_MAIL->addTag('{COMMENTS}', $COM->comments);
            $MGA_MAIL->addTag('{IMG_NAME}', $IMG->name);
            $MGA_MAIL->addTag('{IMG_URL}', $SETTINGS->folder . '/' . ($SETTINGS->modr ? 'picture/' . $IMG->id . '/' . addTitleToUrl(getCategoryName($IMG->cat)) . '/' . addTitleToUrl($IMG->name) . '.html' : 'index.php?cmd=picture&picture=' . $IMG->id));
            $MGA_MAIL->sendMail(
              $COM->name,
              $COM->email,
              $SETTINGS->website,
              $SETTINGS->email,
              $SETTINGS->website,
              $SETTINGS->email,
              '[' . $SETTINGS->website . '] ' . (isset($_POST['approve']) ? $msg_comments17 : $msg_comments18),
              $MGA_MAIL->template(IPATH . 'content/lang/email/comments_' . (isset($_POST['approve']) ? 'approved' : 'rejected') . '.txt')
            );
          }
        }
      }

      header("Location: index.php?cmd=comments");
      exit;
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/comments.php');
    include(PATH . 'content/footer.php');
    break;

  // Sales..
  case "sales":

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu12;

    // View order details..
    if (isset($_GET['view']) && (int) $_GET['view'] > 0) {
      include(PATH . 'content/header.php');
      include(PATH . 'content/sale_view_order.php');
      include(PATH . 'content/footer.php');
      exit;
    }

    // Change status..
    if (isset($_GET['status']) || isset($_POST['update_status'])) {
      // Update status..
      if (isset($_POST['update_status'])) {
        // Set status..
        $status = (isset($_POST['status']) ? (int) ($_POST['status'] - 1) : '0');
        // Change order status..
        $MGA_SALES->changeOrderStatus((int) $_POST['id'], (int) $status);
        // Send email...
        if (isset($_POST['email'])) {
          // Get order information..
          $order = $MGA_SALES->getOrder((int) $_POST['id'], $SETTINGS);
          // Set new status text..
          switch ($status) {
            case '0':
              $st_text = $msg_sales12;
              break;
            case '1':
              $st_text = $msg_sales13;
              break;
            case '2':
              $st_text = $msg_sales14;
              break;
          }
          // Send mail..
          $MGA_MAIL->addTag('{NAME}', $order->first_name . ' ' . $order->last_name);
          $MGA_MAIL->addTag('{TOTAL}', $MGA_CART->formatPrice($order->gross) . ' (' . $PP->ppCurrency . ')');
          $MGA_MAIL->addTag('{INVOICE_NO}', $order->invoice);
          $MGA_MAIL->addTag('{PICTURES}', $MGA_CART->loadPurchasesIntoString($order->cartID, $msg_ipn6, $msg_ipn8, $msg_ipn7));
          $MGA_MAIL->addTag('{DATE}', $order->s_date);
          $MGA_MAIL->addTag('{COMMENTS}', ($_POST['comments'] ? $_POST['comments'] : $msg_sales22));
          $MGA_MAIL->addTag('{STATUS}', $st_text);

          // Send mail to webmaster..
          $MGA_MAIL->sendMail(
            $order->first_name . ' ' . $order->last_name,
            $order->email,
            $SETTINGS->website,
            $SETTINGS->email,
            $SETTINGS->website,
            $SETTINGS->email,
            '[' . $SETTINGS->website . '] ' . $msg_sales21,
            $MGA_MAIL->template(IPATH . 'content/lang/email/status_updated.txt')
          );
        }

        header("Location: index.php?cmd=sales&status=" . (int) $_POST['id'] . "&updated=1");
        exit;
      }
      include(PATH . 'content/header.php');
      include(PATH . 'content/sale_change_status.php');
      include(PATH . 'content/footer.php');
      exit;
    }

    // Delete sales..
    if (isset($_POST['process'])) {
      if (!empty($_POST['id'])) {
        for ($i = 0; $i < count($_POST['id']); $i++) {
          $MGA_SALES->delete($_POST['id'][$i]);
        }
      }
      header("Location: index.php?cmd=sales");
      exit;
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/sales.php');
    include(PATH . 'content/footer.php');
    break;

  // Sales..
  case "selling_options":

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu15;

    // Update image sale options..
    if (isset($_POST['process'])) {
      $count = $MGA_IMAGES->update_sale_options($_POST);
      $OK    = true;
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/selling_options.php');
    include(PATH . 'content/footer.php');
    break;

  // Categories..
  case "cats":

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu4;

    // Add/Edit category..
    if (isset($_POST['process'])) {
      if (isset($_POST['edit'])) {
        $MGA_CATS->update_cat_sql($_POST);
      } else {
        if (trim($_POST['cat'])) {
          $MGA_CATS->add_cat_sql($_POST);
        }
      }

      header("Location: index.php?cmd=cats" . (isset($_POST['edit']) ? '&edit=' . $_POST['edit'] : ''));
      exit;
    }

    // Delete child..
    if (isset($_GET['del'])) {
      $MGA_CATS->delete_cat_sql($_GET['del']);

      header("Location: index.php?cmd=cats");
      exit;
    }

    // Delete cats/children..
    if (isset($_POST['process_del'])) {
      if (!empty($_POST['cat'])) {
        for ($i = 0; $i < count($_POST['cat']); $i++) {
          $MGA_CATS->delete_cat_sql($_POST['cat'][$i], true);
        }
      }

      header("Location: index.php?cmd=cats");
      exit;
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/cats.php');
    include(PATH . 'content/footer.php');
    break;

  // Add new images..
  case "add_images":

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu6;

    // Sales help..
    if (isset($_GET['salehelp'])) {
      include(PATH . 'content/salehelp.php');
      exit;
    }

    // Add images..
    if (isset($_POST['process'])) {
      // Set count var for processing..
      // Set array..
      // Get prefixes for files..
      $processed = 0;
      $report    = [];
      $prefix    = explode("|", IMAGE_PREFIX);

      //  Process files..
      for ($i = 0; $i < count($_POST['path']); $i++) {
        // Only process if name included..
        if (trim($_POST['name'][$i])) {
          // Increment count..
          $count++;

          // Filter path name for fullsize image..
          $path  = $MGA_IMAGES->filter_file_path($_POST['path'][$i], $_POST['cat'][$i], $prefix[0]);
          $tpath = $MGA_IMAGES->filter_file_path($_POST['path'][$i], $_POST['cat'][$i], $prefix[1]);

          // For thumbnail uploads..
          $oname = (isset($_FILES['thumb']['name'][$i]) ? $_FILES['thumb']['name'][$i] : '');
          $name  = (isset($_FILES['thumb']['name'][$i]) ? $MGA_IMAGES->filter_file_path($_FILES['thumb']['name'][$i], $_POST['cat'][$i], $prefix[1]) : '');
          $temp  = (isset($_FILES['thumb']['tmp_name'][$i]) ? $_FILES['thumb']['tmp_name'][$i] : '');
          $size  = (isset($_FILES['thumb']['size'][$i]) ? $_FILES['thumb']['size'][$i] : '');
          $type  = (isset($_FILES['thumb']['type'][$i]) ? $_FILES['thumb']['type'][$i] : '');

          // If upload box is present, is there an upload..
          if (isset($_POST['upload']) && ($name == '' || $temp == '')) {
            $count--;
          }

          // Assign default report vars to array. These never change..
          $report[$i][0] = trim($_POST['name'][$i]);
          $report[$i][1] = getFolderName($_POST['cat'][$i]);
          $report[$i][2] = getCategoryName($_POST['cat'][$i]);

          // Process if count is ok..
          if ($count > 0) {
            // Create/upload thumbnail..
            if ($SETTINGS->autothumb) {
              if (is_dir(GPATH . 'content/galleries/' . $SETTINGS->folder_name . '/' . getFolderName($_POST['cat'][$i]))) {
                if ($MGA_IMAGES->create_thumbnail(GPATH . 'content/galleries/new/', $_POST['path'][$i], $SETTINGS->autowidth, $SETTINGS->autoheight, GPATH . 'content/galleries/' . $SETTINGS->folder_name . '/' . getFolderName($_POST['cat'][$i]) . '/', $tpath)) {
                } else {
                  $report[$i][3] = 'error_create';
                  $report[$i][4] = $_POST['path'][$i];
                  $s1_error      = true;
                }
              } else {
                $report[$i][3] = 'error_create_dir';
                $report[$i][4] = $_POST['path'][$i];
                $s1_error      = true;
              }
            } else {
              if (is_dir(GPATH . 'content/galleries/' . $SETTINGS->folder_name . '/' . getFolderName($_POST['cat'][$i]))) {
                if (!isset($s1_error) && substr($type, 0, 5) == 'image' && $name && $temp && $MGA_IMAGES->upload_thumbnail($name, $temp, GPATH . 'content/galleries/' . $SETTINGS->folder_name . '/' . getFolderName($_POST['cat'][$i]) . '/')) {
                } else {
                  $report[$i][3] = 'error_upload';
                  $report[$i][4] = $_POST['path'][$i];
                  $s1_error      = true;
                }
              } else {
                $report[$i][3] = 'error_upload_dir';
                $report[$i][4] = $_POST['path'][$i];
                $s1_error      = true;
              }
            }

            // Move image..
            if (!isset($s1_error)) {
              if ($MGA_IMAGES->move_to_new_directory(GPATH . 'content/galleries/new/', $_POST['path'][$i], GPATH . 'content/galleries/' . $SETTINGS->folder_name . '/' . getFolderName($_POST['cat'][$i]) . '/', $path)) {
              } else {
                $report[$i][3] = 'error_move';
                $s2_error      = true;
                $report[$i][4] = $_POST['path'][$i];
              }
            }

            // Add to database..
            if (!isset($s1_error) && !isset($s2_error)) {
              if ($MGA_IMAGES->insert_image_sql($_POST, $i, ($name ? $name : $tpath), $size, $path)) {
              } else {
                $report[$i][3] = 'error_db';
                $s3_error      = true;
                $report[$i][4] = $_POST['path'][$i];
              }
            }

            // If no errors, everything is ok..yippee..
            if (!isset($s1_error) && !isset($s2_error) && !isset($s3_error)) {
              $report[$i][3] = 'ok';
              $report[$i][4] = ($name ? $name : $tpath);
            }

            // Assign directory name...
            $report[$i][5] = 'content/galleries/' . $SETTINGS->folder_name . '/' . getFolderName($_POST['cat'][$i]);

            // Reset count for next loop..
            $processed++;
            $count = 0;
            unset($s1_error, $s2_error, $s3_error);
          }
        }
      }

      // Show upload report if at least 1 file was added..
      if ($processed > 0) {
        include(PATH . 'content/header.php');
        include(PATH . 'content/add_image_report.php');
        include(PATH . 'content/footer.php');
      } else {
        header("Location: index.php?cmd=add_images");
      }
      exit;
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/add_images.php');
    include(PATH . 'content/footer.php');
    break;

  // E-Mail Addresses..
  case "emails":

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu17;

    // Add..
    if (isset($_POST['process'])) {
      if (trim($_POST['email']) && isValMail($_POST['email'])) {
        $MGA_EMAILS->add($_POST);
      }
      header("Location: index.php?cmd=emails");
      exit;
    }

    // Remove selected..
    if (isset($_POST['process_del'])) {
      if (isset($_POST['email'])) {
        $MGA_EMAILS->delete($_POST);
      }
      header("Location: index.php?cmd=emails");
      exit;
    }

    // Clear all..
    if (isset($_GET['clear'])) {
      $MGA_EMAILS->clear();
      header("Location: index.php?cmd=emails");
      exit;
    }

    // Import to CSV
    if (isset($_GET['csv'])) {
      $MGA_EMAILS->csv($msg_settings4, GPATH);
      exit;
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/email_addresses.php');
    include(PATH . 'content/footer.php');
    break;

  // Ban Options..
  case "ban":

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu16;
    $SQL       = '';

    // Add..
    if (isset($_POST['process'])) {
      if (trim($_POST['data'])) {
        $MGA_BAN->add($_POST);
      }
      header("Location: index.php?cmd=ban");
      exit;
    }

    // Remove selected..
    if (isset($_POST['process_del'])) {
      if (isset($_POST['ban'])) {
        $MGA_BAN->delete($_POST);
      }
      header("Location: index.php?cmd=ban");
      exit;
    }

    // Clear all..
    if (isset($_GET['clear'])) {
      $MGA_BAN->clear();
      header("Location: index.php?cmd=ban");
      exit;
    }

    // Sql filtering..
    if (isset($_GET['show'])) {
      switch ($_GET['show']) {
        case 'email':
          $SQL = "WHERE address LIKE '%@%'";
          break;
        case 'ip':
          $SQL = "WHERE address NOT LIKE '%@%' AND address NOT LIKE '%*%'";
          break;
        case 'wildcard':
          $SQL = "WHERE address LIKE '%*%'";
          break;
      }
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/ban.php');
    include(PATH . 'content/footer.php');
    break;

  // Image Management..
  case "manage":

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu7;

    include(PATH . 'content/header.php');
    include(PATH . 'content/categories.php');
    include(PATH . 'content/footer.php');
    break;

  // Show cat images..
  case 'cat_images':

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu7;

    // View/update comments..
    if (isset($_GET['comments'])) {
      if (isset($_POST['edit_comment'])) {
        $MGA_IMAGES->update_comment($_POST);
      }
      include(PATH . 'content/header.php');
      include(PATH . 'content/image_comments.php');
      include(PATH . 'content/footer.php');
      exit;
    }

    // Edit image..
    if (isset($_GET['edit']) || isset($_POST['edit'])) {
      if (isset($_POST['process'])) {
        if (trim($_POST['name'])) {
          $MGA_IMAGES->update_image_sql($_POST);
          $UPDATED = true;
        }
      }

      include(PATH . 'content/header.php');
      include(PATH . 'content/edit_image.php');
      include(PATH . 'content/footer.php');
      exit;
    }

    // View image..
    if (isset($_GET['img']) || isset($_GET['new_img'])) {
      include(PATH . 'content/view_image.php');
      exit;
    }

    // Remove selected images..
    if (isset($_POST['process_del'])) {
      if (!empty($_POST['img'])) {
        $MGA_IMAGES->delete_images($_POST, GPATH . 'content/galleries/' . $SETTINGS->folder_name . '/' . $_POST['folder']);
      }

      header("Location: index.php?cmd=cat_images&cat=" . (int) $_POST['cat']);
      exit;
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/cat_images.php');
    include(PATH . 'content/footer.php');
    break;

  // Search..
  case "search":

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu5;

    // Search database..
    if (isset($_GET['search'])) {
      $search_data = [];
      $sql_string  = '';
      $keys        = '';

      if ($_GET['from_day'] && $_GET['from_month'] && $_GET['from_year']) {
        $from_date_string = $_GET['from_year'] . '-' . $_GET['from_month'] . '-' . $_GET['from_day'];
      }
      if ($_GET['to_day'] && $_GET['to_month'] && $_GET['to_year']) {
        $to_date_string = $_GET['to_year'] . '-' . $_GET['to_month'] . '-' . $_GET['to_day'];
      }

      // Build search data array..
      if (trim($_GET['keywords'])) {
        $split = explode(" ", $_GET['keywords']);
        for ($i = 0; $i < count($split); $i++) {
          $keys .= ($i ? "OR name LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR comments LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR details LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' " : "name LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR comments LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR details LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' ");
        }
        $search_data[] = $keys;
      }
      if ($_GET['cat'] > 0) {
        $search_data[] = "cat = '{$_GET['cat']}'";
      }
      if (isset($from_date_string) && isset($to_date_string)) {
        $search_data[] = "addDate BETWEEN '{$from_date_string}' AND '{$to_date_string}'";
      }

      // Has search data been specified..
      if (!empty($search_data)) {
        // Build query string..
        for ($i = 0; $i < count($search_data); $i++) {
          $sql_string .= ($i ? 'AND ' . $search_data[$i] : 'WHERE ' . $search_data[$i]);
        }

        //Now query database
        $q_search = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT * FROM " . DB_PREFIX . "images
                               $sql_string
                               ORDER BY name
                               LIMIT $limitvalue,$limit
                               ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));

        if (mysqli_num_rows($q_search) > 0) {
          $SEARCH_RESULTS = true;
        } else {
          $NO_RESULTS = true;
        }
      } else {
        header("Location: index.php?cmd=search");
        exit;
      }
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/search.php');
    include(PATH . 'content/footer.php');
    break;

  // Search..
  case "searchsales":

    // Check login..
    isWebmasterLoggedIn();

    $pageTitle = $msg_adminmenu18;

    // Search database..
    if (isset($_GET['search'])) {
      $search_data = [];
      $sql_string  = '';
      $keys        = '';

      if ($_GET['from_day'] && $_GET['from_month'] && $_GET['from_year']) {
        $from_date_string = $_GET['from_year'] . '-' . $_GET['from_month'] . '-' . $_GET['from_day'];
      }
      if ($_GET['to_day'] && $_GET['to_month'] && $_GET['to_year']) {
        $to_date_string = $_GET['to_year'] . '-' . $_GET['to_month'] . '-' . $_GET['to_day'];
      }

      // Build search data array..
      if (trim($_GET['keywords'])) {
        $split = explode(" ", $_GET['keywords']);
        for ($i = 0; $i < count($split); $i++) {
          $keys .= ($i ? "OR first_name LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR last_name LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR address LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR email LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR txn_id = '" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "' OR invoice = '" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "' " : "first_name LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR last_name LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR address LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR email LIKE '%" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "%' OR txn_id = '" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "' OR invoice = '" . mysqli_real_escape_string($GLOBALS["___mysqli_ston"], $split[$i]) . "' ");

        }
        $search_data[] = $keys;
      }
      if (isset($from_date_string) && isset($to_date_string)) {
        $search_data[] = "pay_date BETWEEN '{$from_date_string}' AND '{$to_date_string}'";
      }

      // Has search data been specified..
      if (!empty($search_data)) {
        // Build query string..
        for ($i = 0; $i < count($search_data); $i++) {
          $sql_string .= ($i ? 'AND (' . $search_data[$i] . ')' : 'WHERE ' . $search_data[$i]);
        }

        //Now query database
        $q_search = mysqli_query($GLOBALS["___mysqli_ston"], "SELECT *,DATE_FORMAT(pay_date,'" . $SETTINGS->mysql_date . "') AS s_date
                               FROM " . DB_PREFIX . "ipndata
                               $sql_string
                               AND activeCart = '1'
                               ORDER BY id
                               LIMIT $limitvalue,$limit
                               ") or die(mysqli_error($GLOBALS["___mysqli_ston"]));

        if (mysqli_num_rows($q_search) > 0) {
          $SEARCH_RESULTS = true;
        } else {
          $NO_RESULTS = true;
        }
      } else {
        header("Location: index.php?cmd=searchsales");
        exit;
      }
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/searchsales.php');
    include(PATH . 'content/footer.php');
    break;

  // Login..
  case "login":

    // If already logged in, direct to homepage..
    if (isset($_SESSION['mgallery_admin_session' . ADM_KEY]) || isset($_COOKIE['mgallery_admin_cookie' . ADM_KEY])) {
      header("Location: index.php");
      exit;
    }

    $pageTitle = $msg_adminlogin5;

    // Process login..
    if (isset($_POST['process'])) {
      // Use callback function to prepare data for importing..
      $_POST = array_map('trim', $_POST);

      if (encrypt(ADM_USER) != encrypt($_POST['user'])) {
        $u_error = true;
      }
      if (encrypt(ADM_PASS) != encrypt($_POST['pass'])) {
        $p_error = true;
      }
      if (!isset($u_error) && !isset($p_error)) {
        $_SESSION['mgallery_admin_session' . ADM_KEY] = encrypt($_POST['user']);

        if (isset($_POST['cookie'])) {
          setcookie(COOKIE_NAME, encrypt(SECRET_KEY), time() + 60 * 60 * 24 * 30);
        }

        header("Location: index.php");
        exit;
      }
    }

    include(PATH . 'content/header.php');
    include(PATH . 'content/login.php');
    include(PATH . 'content/footer.php');
    break;

  // Logout..
  case "logout":

    session_unset();
    session_destroy();
    setcookie('PHPSESSID', 0, time() - 3600);

    if (isset($_COOKIE[COOKIE_NAME . ADM_KEY])) {
      setcookie(COOKIE_NAME . ADM_KEY, "");
      unset($_COOKIE);
    }

    unset($_SESSION);

    header("Location: index.php?cmd=login");

    break;

  case 'watermark':

    // Check login..
    isWebmasterLoggedIn();

    $MGA_WMARK->waterMarkText = ($SETTINGS->watertext ? cleanData($SETTINGS->watertext) : $msg_script32);
    $MGA_WMARK->imagePath     = 'content/images/watermark/wmtestpic.jpg';
    $MGA_WMARK->font          = GPATH . 'content/watermark-fonts/' . ($SETTINGS->waterfont ? $SETTINGS->waterfont : 'Arial') . '.ttf';
    $MGA_WMARK->size          = $SETTINGS->watersize;
    $MGA_WMARK->red           = $SETTINGS->watertextr;
    $MGA_WMARK->green         = $SETTINGS->watertextg;
    $MGA_WMARK->blue          = $SETTINGS->watertextb;
    $MGA_WMARK->hSpacing      = $SETTINGS->waterhspace;
    $MGA_WMARK->vSpacing      = $SETTINGS->watervspace;
    $MGA_WMARK->angle         = $SETTINGS->waterangle;

    header("Content-type: image/jpeg");
    $MGA_WMARK->mark();
    echo $MGA_WMARK->imageResource;
    exit;

    break;
}

?>