<?php

class rss_Feed {

  var $xml_version = '1.0';
  var $encoding = 'utf-8';
  var $rss_version = '2.0';
  var $path;

  // Starts RSS Channel..
  public function open_channel() {
    $xml_string = '<?xml version="' . $this->xml_version . '" encoding="' . $this->encoding . '"?>
    <?xml-stylesheet type="text/css" href="' . $this->path . 'css/rss.css" ?>
    <rss version="' . $this->rss_version . '">
    <channel>';

    return $xml_string;
  }

  //Loads data into Feed..
  public function add_item($title = '', $link = '', $date = '', $desc = '') {
    $xml_string = '
    <item>
     <title>' . $this->render($title) . '</title>
     <link>' . $link . '</link>
     <pubDate>' . $date . '</pubDate>
     <guid>' . $link . '</guid>
     <description>' . $this->render($desc, true) . '</description>
    </item>';
    return $xml_string;
  }

  // Loads Feed Info..
  public function feed_info($title = '', $link = '', $date = '', $desc = '', $site = '') {
    $xml_string = '
    <title>' . $this->clean($title) . '</title>
    <link>' . $link . '</link>
    <description>' . $this->clean($desc) . '</description>
    <lastBuildDate>' . $date . '</lastBuildDate>
    <language>en-us</language>
    <generator>' . $this->render($site) . '</generator>';
    return $xml_string;
  }

  // Closes RSS Channel..
  public function close_channel() {
    $xml_string = '
    </channel>
    </rss>';
    return $xml_string;
  }

  // Renders Feed Data..
  public function render($data, $clean_tags = false) {
    if ($clean_tags) {
      $data = $this->remove_tags($data);
    }

    return '<![CDATA[' . $this->clean($data) . ']]>';
  }

  // Removes certain tags from feed..
  public function remove_tags($data) {
    return strip_tags((string) $data, '<b><strong><p><br><img><i><a><u>');
  }

  // Cleans data..
  public function clean($data) {
    return $data;
  }

}

?>