<?php

define('SYS_ROOT_PATH', __dir__ . '/../../../');
include(SYS_ROOT_PATH . 'control/classes/mailer/src/Exception.php');
include(SYS_ROOT_PATH . 'control/classes/mailer/src/SMTP.php');
include(SYS_ROOT_PATH . 'control/classes/mailer/src/PHPMailer.php');

class mailClass extends PHPMailer\PHPMailer\PHPMailer {

  public $vars = array();
  public $smtp_host;
  public $smtp_port;
  public $smtp_user;
  public $smtp_pass;
  public $smtp_en = 0;
  public $html = false; // Set to true to use HTML in e-mail templates
  public $smtp_sec = ''; // tls, ssl or blank

  // Mail debug log..
  private $debug = 'no';
  private $debug_log_file = 'mail-debug-log.log';

  // Allow insecure connections..
  // Use at your own risk..
  // yes or no value
  private $allowInsecure = 'no';
  
  // Preferred language
  // Must be supported language
  private $mail_lang = 'en';

  // Cleans slashes..
  function cleanData($data) {
    return $data;
  }

  // Converts entities..
  function convertChar($data) {
    $find    = array('&#039;','&quot;','&amp;','&lt;','&gt;');
    $replace = array('\'','"','&','<','>');

    return str_replace($find,$replace,$data);
  }

  // Loads tags into array..
  function addTag($placeholder,$data) {
    $this->vars[$placeholder] = $data;
  }

  // Clears data vars..
  function clearVars() {
    $this->vars = array();
  }

  // Converts tags..
  function convertTags($data) {
    if (!empty($this->vars)) {
      foreach ($this->vars AS $tags => $value) {
        $data = str_replace($tags,$value,$data);
      }
    }

    return $data;
  }

  // Mail headers..
  function mailHeaders($name,$email) {
    global $mail_charset;
    if ($this->html) {
      $headers  = "Content-type: text/html; charset=".$mail_charset."\r\n";
      $headers .= "From: \"".$this->injectionCleaner($name)."\" <".$email.">\n";
    } else {
      $headers  = "Content-type: text/plain; charset=".$mail_charset."\r\n";
      $headers .= "From: \"".$this->injectionCleaner($name)."\" <".$email.">\n";
    }

    $headers .= "X-Sender: \"".$this->injectionCleaner($name)."\" <".$email.">\n";
    $headers .= "X-Mailer: PHP\n";
    $headers .= "X-Priority: 3\n";
    $headers .= "X-Sender-IP: ".$_SERVER['REMOTE_ADDR']."\n";
    $headers .= "Date: ".date("r")."\n";
    $headers .= "Return-Path: \"".$this->injectionCleaner($name)."\" <".$email.">\n";
    $headers .= "Reply-To: \"".$this->injectionCleaner($name)."\" <".$email.">\n";

    return $headers;
  }

  // Cleans spam/form injection input..
  function injectionCleaner($data) {
    $find = array(
     "\r",
     "\n",
     "%0a",
     "%0d",
     "content-type:",
     "Content-Type:",
     "BCC:",
     "CC:",
     "boundary=",
     "TO:",
     "bcc:",
     "to:",
     "cc:"
     );
    $replace = array();
    return str_replace($find,$replace,$data);
  }

  // Loads e-mail template..
  function template($file) {
    $email_string = trim(file_get_contents($file));
    return ($email_string ? trim($this->convertTags($email_string)) : die('An error occurred opening the <b>'.$file.'</b> file. Check that this file exists in the correct "content/email/" folder!'));
  }

  // Sends mail..
  // If you are testing the script on localhost and you don`t have mail
  //  capabilities, set the $email var to false to disable mail sending.
  function sendMail($to_name,$to_email,$from_name,$from_email,$rep_name,$rep_email,$subject,$msg,$email=true) {
    if ($email) {
      // Additional stripping of too many chars..ie: spammers
      $to_name     = substr($to_name,0,250);
      $to_email    = substr($to_email,0,250);
      $from_name   = substr($from_name,0,250);
      $from_email  = substr($from_email,0,250);
      if ($this->smtp_en) {
        $this->IsSMTP();
        $this->IsHTML($this->html);
        $this->Port       = $this->smtp_port;
        $this->Host       = $this->smtp_host;
        $this->SMTPAuth   = ($this->smtp_user && $this->smtp_pass ? true : false);
        $this->SMTPSecure = (in_array($this->smtp_sec, array(
          '',
          'tls',
          'ssl'
        )) ? $this->smtp_sec : '');
        // Allow insecure connections?
        if ($this->allowInsecure == 'yes') {
          $this->SMTPOptions = array(
            'ssl' => array(
              'verify_peer' => false,
              'verify_peer_name' => false,
              'allow_self_signed' => true
            )
          );
        }
        $this->Username   = $this->smtp_user;
        $this->Password   = $this->smtp_pass;
        $this->From       = $from_email;
        $this->FromName   = $this->convertChar($this->cleanData($this->injectionCleaner($from_name)));
        $this->AddAddress($to_email, $this->convertChar($this->cleanData($this->injectionCleaner($to_name))));
        $this->AddReplyTo($rep_email, $rep_name);
        $this->WordWrap   = 1000;
        $this->CharSet    = 'utf-8';
        // Enable debug..
        if ($this->debug == 'yes') {
          $this->SMTPDebug = 2;
          $this->Debugoutput = function($str, $level) {
            file_put_contents(SYS_ROOT_PATH . 'logs/' . $this->debug_log_file, $str . PHP_EOL, FILE_APPEND);
          };
        }
        $this->Subject    = $this->convertChar($this->cleanData($subject));
        $this->Body       = $this->convertChar($this->cleanData($msg));
        // Language
        if ($this->mail_lang != 'en') {
          $this->setLanguage($this->mail_lang, SYS_ROOT_PATH . 'control/classes/mailer/language/');
        }
        $this->Send();
      } else {
        mail($to_email,
             $this->convertChar($this->cleanData($subject)),
             $this->convertChar($this->cleanData($msg)),
             $this->mailHeaders($this->cleanData($this->convertChar($from_name)),$from_email)
             );
      }
    }
  }

}

?>
